   function [q,h,gen,spher]= gaskettues(q,h,gen,spher,error)
% example:
%  q=[-1;2;2;3]
% h=[0;1;-1;2i]
% 
% gen=4
% spher=0
% error=1
%plots the intial four circles, input the above variables

 if error==1,
circle([real( h(1)/q(1) ),imag( h(1)/q(1) )], 1/q(1),1000,'-',spher);
 end

 
circle([real( h(2)/q(2) ),imag( h(2)/q(2) )], 1/q(2) ,1000,'-',spher);
hold on;
circle([real( h(3)/q(3) ),imag( h(3)/q(3) )], 1/q(3) ,1000,'-',spher);
circle([real( h(4)/q(4) ),imag( h(4)/q(4) )], 1/q(4) ,1000,'-',spher);
 

%boss loop, generates curvatures

if gen == 5,
for i=1:4
    for j=1:4
        for k = 1:4
            for l=1:4
                for m=1:4
                if ((m ~= l) && (l ~= k) && (k ~= j) && (j ~= i)) 
        [q2,h2,spher] = boss(i,q,h,spher);
        [q3,h3,spher] = boss(j,q2,h2,spher);
        [q4,h4,spher] = boss(k,q3,h3,spher);
        [q5,h5,spher] = boss(l,q4,h4,spher);
        boss(m,q5,h5,spher);
                end
                end
            end
        end
    end
end
end

if gen==4,
for i=1:4
    for j=1:4
        for k = 1:4
            for l=1:4
                if ((l ~= k) && (k ~= j) && (j ~= i)) 
        [q2,h2,spher] = boss(i,q,h,spher);
        [q3,h3,spher] = boss(j,q2,h2,spher);
        [q4,h4,spher] = boss(k,q3,h3,spher);
        boss(l,q4,h4,spher);
        axis square;
                end
            end
        end
    end
end
end

if gen==3,
for i=1:4
    for j=1:4
        for k = 1:4
                if ((k ~= j) && (j ~= i)) 
        [q2,h2,spher] = boss(i,q,h,spher);
        [q3,h3,spher] = boss(j,q2,h2,spher);
        boss(k,q3,h3,spher);
                end
        end
    end
end
end

if gen==2,
for i=1:4
    for j=1:4
                if ((j ~= i)) 
        [q2,h2,spher] = boss(i,q,h,spher);
        boss(j,q2,h2,spher);
                end
    end
end
end

if gen==1,
for i=1:4
         boss(i,q,h,spher);
end
end